----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:20:48 01/12/2009 
-- Design Name: 
-- Module Name:    ramX16Nd - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-------------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;
library UNISIM;
use UNISIM.VComponents.all;
entity ram16XNd is
    generic ( N: positive := 16);
    port (
        clk: in STD_LOGIC;
        we: in STD_LOGIC;
        d: in STD_LOGIC_VECTOR (N-1 downto 0);
        a: in STD_LOGIC_VECTOR (3 downto 0);
        dpra: in STD_LOGIC_VECTOR (3 downto 0);
        spo: out STD_LOGIC_VECTOR (N-1 downto 0);
        dpo: out STD_LOGIC_VECTOR (N-1 downto 0)
    );
end ram16XNd;
architecture my_arch of ram16XNd is
begin
g0: for i in d'range generate
ram: ram16x1d
    port map(
             we => we,
             wclk => clk,
             d => d(i),
             a0 => a(0),
             a1 => a(1),
             a2 => a(2),
             a3 => a(3),
             dpra0 => dpra(0),
             dpra1 => dpra(1),
             dpra2 => dpra(2),
             dpra3 => dpra(3),
             spo => spo(i),
             dpo => dpo(i));
end generate;
end my_arch;

